'use strict';

var register = require('./register-5feed80c.js');

var convertAttrToString = function convertAttrToString(attr) {
  var results = [];

  var keys = register._Object$keys(attr);

  for (var i = 0; i < keys.length; i++) {
    var _context;

    var key = keys[i];
    results.push(register._concatInstanceProperty(_context = " ".concat(key, "=\"")).call(_context, attr[key], "\""));
  }

  return results.join('');
};
var getHeadHtml = function getHeadHtml(heads) {
  var results = [];

  for (var i = 0; i < heads.length; i++) {
    var h = heads[i];

    if (h.type === 'meta') {
      results.push("<meta".concat(convertAttrToString(h.props), ">"));
    }

    if (h.type === 'title') {
      results.push("<title>".concat(h.props.children, "</title>"));
    }

    if (h.type === 'link') {
      results.push("<link".concat(convertAttrToString(h.props), ">"));
    }

    if (h.type === 'script') {
      results.push("<script".concat(convertAttrToString(h.props), "></script>"));
    }
  }

  return results.join('');
};

exports.convertAttrToString = convertAttrToString;
exports.getHeadHtml = getHeadHtml;
